#include <stdio.h>

#define LEFT(i) 2*(i)
#define RIGHT(i) 2*(i)+1
#define PARENT(i) (i)/2

struct HeapVrchol
{
   int vrchol;
   int value;
};

struct HeapVrchol heap[10000];
int heapSize = 0;

void vymenCisla(int *a, int *b)
{
   int tmp = *a;
   
   *a = *b;
   *b = tmp;
}

void heapify(struct HeapVrchol *heap, int i, int heapSize)
{
   int najvacsi, tmp;
   
   int l = LEFT(i);
   int r = RIGHT(i);
   
   najvacsi = ((l <= heapSize) && (heap[l].value < heap[i].value)) ? l : i);
   
   if((r <= heapSize) && (heap[r].value < heap[najvacsi].value))
      najvacsi = r;
      
   if(najvacsi != i)
   {
      vymenCisla(&(heap[i].value), &(heap[najvacsi].value));
      tmp = heap[i].vrchol;
      heap[i].vrchol = heap[najvacsi].vrchol;
      heap[najvacsi].vrchol = tmp;
      
      heapify(heap, najvacsi, heapSize);
   }
}


void heapInsert(int vrchol, int dlzka)
{
   heapSize++;
   int i = heapSize;
   
   if(heapSize == 1)
   {
      heap[i].vrchol = vrchol;
      heap[i].value = dlzka;
      
      return ;
   
   }

   while(i > 1 && heap[PARENT(i)].value > dlzka)
   {
      heap[i].value = heap[PARENT(i)].value;
      heap[i].vrchol = heap[PARENT(i)].vrchol;
      i = PARENT(i);
   }
   
   
   heap[i].vrchol = vrchol;
   heap[i].value = dlzka;
}

int heapNajmensiVrchol()
{
   int min;
   
   min = heap[1].vrchol;
   heap[1] = heap[heapSize];
   
   heapSize--;
   
   heapify(heap, 1, heapSize);
   
   return min;
}






int main(void) 
{
  
   return 0;
}
